- NAME
- SYNOPSIS
- DESCRIPTION
- RETURN VALUES
- SEE ALSO
- HISTORY
- COPYRIGHT

# NAME

CMS_digest_create_ex, CMS_digest_create - Create CMS DigestedData object

# SYNOPSIS

     #include <openssl/cms.h>

     CMS_ContentInfo *CMS_digest_create_ex(BIO *in, const EVP_MD *md,
                                           unsigned int flags, OSSL_LIB_CTX *ctx,
                                           const char *propq);

     CMS_ContentInfo *CMS_digest_create(BIO *in, const EVP_MD *md,
                                        unsigned int flags);

# DESCRIPTION

`CMS_digest_create_ex()` creates a CMS_ContentInfo structure with a type NID_pkcs7_digest. The data supplied via the in BIO is digested using md. The library context libctx and the property query propq are used when retrieving algorithms from providers. The flags field supports the CMS_DETACHED and CMS_STREAM flags, Internally `CMS_final()` is called unless CMS_STREAM is specified.

The CMS_ContentInfo structure can be freed using CMS_ContentInfo_free(3).

`CMS_digest_create()` is similar to `CMS_digest_create_ex()` but uses default values of NULL for the library context libctx and the property query propq.

# RETURN VALUES

If the allocation fails, `CMS_digest_create_ex()` and `CMS_digest_create()` return NULL and set an error code that can be obtained by ERR_get_error(3). Otherwise they return a pointer to the newly allocated structure.

# SEE ALSO

ERR_get_error(3), CMS_final(3)>

# HISTORY

The `CMS_digest_create_ex()` method was added in OpenSSL 3.0.

# COPYRIGHT

Copyright 2020-2021 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.